open Bsml ;;
open Stdlib.Base ;;
open Tools ;;
open NatTools ;;
open Specification ;;
open Datatypes ;;
open Benchmarking;;
open StdlibTest;;

module  Printer : TEST_PARAMETERS = 
  struct 
  let print_result =
    fun s n b ->
      ignore (doat0 (fun () -> print_endline ("bsml on "^(string_of_int bsp_p)^" procs, certified sequential simulating "^(string_of_nat n)^" procs, "^s ^(if b then "_ success _"else "X failed X"))))
 end

  
module Test_1 = Tester_1 (BsmlNat.Primitives)  (Printer) ;;

module Test_2 = Tester_2 (BsmlNat.Primitives)  (Printer) ;;

module Test_4 = Tester_4 (BsmlNat.Primitives)  (Printer) ;;

module Test_7 = Tester_7 (BsmlNat.Primitives)  (Printer) ;;

module Test_8 = Tester_8 (BsmlNat.Primitives)  (Printer) ;;
