Require Import List.

Section map2.
  Variable A B C : Type.
Fixpoint map2 (f : A -> B ->C) (la: list A) (lb : list B)  : list C :=
  match la with 
    | nil => nil
    | ha::ta => match lb with 
                | nil => nil
                  | hb::tb => (f ha hb)::(map2 f ta tb)
              end
  end.
End map2.
