
(** Tactic for recursive elimination of existantial quantifier in hypothesis*)
Tactic Notation "elim_ex" constr(e):=
  repeat (
    match (type of e) with 
      | exists x,_ => 
        elim e;clear e; let H:=fresh "x"  in intros H e
      | _ => fail
    end
    ).
(** Tactic for recursive elimination of existantial quantifier in hypothesis limited to depth [n]*)
Tactic Notation "elim_ex" constr(e) integer(n):=
  do n (
    match (type of e) with 
      | exists x,_ => 
        elim e;clear e; let H:=fresh in intros H e
      | _ => fail
    end
    ).

(** Admiting with a warning message  *)
Ltac myadmit s1 s2 :=    
  match goal with 
    [|- ?G ] => 
  idtac "Warning :  admit in file" s1".v, lemma" s2 "goal :" G
  end ; admit.
