open Bsml
open Specification 
open Stdlib
open Base 
open Datatypes 
open Nat_tools

module Bsml_natural : (PRIMITIVES with type 'a par = 'a Bsml.par)=
struct

  let  bsp_p : nat = nat_of_int (bsp_p)
    
  (* let bsp_p : nat = S max_pid *)
    
  type processor = nat
  type 'a par = 'a Bsml.par
      
  (* let nat_of_processor : processor -> nat = fun i -> i *)
    
  (* let processor_of_nat : nat -> processor = fun i -> i *)
    
  (* let processor0 : processor = nat_of_int 0 *)
    
  (* let processor_max : processor = max_pid *)
    
  let get : 'a1 par -> processor -> 'a1 =
    fun v i -> failwith "should not be called"
    
  let mkpar : (processor -> 'a1) -> 'a1 par =
    fun f -> Bsml.mkpar (fun i -> f (nat_of_int i))

    
  let apply : ('a1 -> 'a2) par -> 'a1 par -> 'a2 par =
    Bsml.apply
      
  let put : (processor -> 'a1) par -> (processor -> 'a1) par =
    fun v ->
      Base.parfun
	(* transform the put result into a function taking nat as input (instead of int)  *)
	(fun f -> (fun n -> f (int_of_nat n)))
	(Bsml.put
	   (*transform the input vector into a vector of function taking int as input (instead of nat)    *)
	   (Base.parfun (fun f -> (fun i -> f (nat_of_int i))) v)
	)
    
  let proj : 'a1 par -> (processor -> 'a1) =
    fun v -> (fun n -> Bsml.proj  v (int_of_nat n))

  let _ = 
    for i=0 to Bsml.bsp_p-1 do
      let n = nat_of_int i in
      let i' = int_of_nat n in
	()
    done

end
