open Bsml
open Stdlib.Base
open Stdlib.Comm
open List

let rec last lst = 
match lst with
    [] -> failwith "empty list "
  | [a] -> a
  |  h::t -> last t


let scan left op lst = 
  let rec  aux left lst res =
    match lst with
      | [] -> res
      | h::t -> let a = op left h in  aux a t (a::res)
  in
    rev(  aux left lst [])

let mps v =
  let sums = scan_wide scan_direct (scan 0.) last map (+.) v in
    proj (fold_list_direct max sums) 0
