open Bsml
open Stdlib
open Base
open Tower_building_direct_implementation

let rec string_of_list string_of_element separator = function 
  |[]  -> ""
  |[h] ->string_of_element h
  |h::t->(string_of_element h)^separator^
     (string_of_list string_of_element separator t)

let string_of_bool b = 
  if b then "true" else "false"

let v1 = mkpar(fun i->[(float (i+1))*.10., 10.*.float(bsp_p-abs((bsp_p/2)-i))])

let v1' = tower_building (0.,40.) v1 (100.,40.) 10.

let v2 = mkpar(fun i->[(float (i+1))*.100., 100.+.6.*.float(Random.int 50)])

let v2' = tower_building (0.,500.) v2 (1000.,500.) 20.

let print = parprint (fun l->print_string(string_of_list string_of_bool ";" l))

let sync () = put(replicate(fun i->()))

let _ = 
  begin
    bsml_print print_string 0 (replicate "v1'=\n");
    sync();
    print v1';
    sync();
    bsml_print print_string 0 (replicate "\nv2'=\n");
    sync();
    print v2'
  end

  



