open Bsml
open Stdlib
open Base
open Comm
open Tower_building_direct_implementation

let data i j=
  Random.self_init(); 
  let rec data_aux i l size=
  if i = 0 then l else data_aux  (i-1) ((float_of_int ((i+j*size)), (float_of_int (Random.int 1000)))::l) size
  in
    data_aux i [] i

let datapar i =
  mkpar (data (i/bsp_p))

let _ = 
  begin
    if Array.length(Bsml.argv)=2
    then
      let length = int_of_string(Bsml.argv.(1)) in
	(let v = datapar length in
	   start_timing();
	   let vl = tower_building (0.,500.) v (float(length),500.) 10. in
	     stop_timing());
	ignore(bsml_print print_float 0 (fold_direct max (get_cost())))
    else
      print_string "give a length as argument\n"
  end

  



