open Tower_building

module Tower_float : (TOWER_PARAMETERS with type coq_A = float) =
struct

  type coq_A = float
  
  let eq_A_dec : coq_A -> coq_A -> bool =
    fun a b -> a == b
  let totR : coq_A -> coq_A -> bool =
    fun a b -> a < b

  let coq_R_dec : coq_A -> coq_A -> bool =
    fun a b -> a < b
  
  let coq_AngleL : coq_A -> coq_A -> coq_A -> coq_A -> coq_A=
    fun xL hL xi hi ->  (hi -. hL) /. (xi -. xL)
  
  let coq_AngleR : coq_A -> coq_A -> coq_A -> coq_A -> coq_A=
    fun xR hR xi hi ->  (* let _ = print_float xi in  *) (hi -. hR) /. (xR -. xi)
  
  let preprocess_L_x : coq_A -> coq_A=
    fun a -> a
  
  let preprocess_L_h : coq_A -> coq_A=
    fun a -> a
  
  let preprocess_R_x : coq_A -> coq_A=
    fun a -> a
  
  let preprocess_R_h : coq_A -> coq_A=
    fun a -> a
 end
